unit ErrFunc;
{ Choix de la fonction d'erreur }

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, Spin,
  uTypes, uVarMod;

type
  TErrFuncDlg = class(TForm)
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    HelpBtn: TBitBtn;
    RadioGroup1: TRadioGroup;
    GroupBox1: TGroupBox;
    Label1: TLabel;
    GroupBoxVar: TGroupBox;
    LabelVar1: TLabel;
    EditVar1: TEdit;
    LabelVar2: TLabel;
    EditVar2: TEdit;
    LabelVar3: TLabel;
    EditVar3: TEdit;
    CheckBox1: TCheckBox;
    Label2: TLabel;
    SpinEdit1: TSpinEdit;
    RadioGroup2: TRadioGroup;
    procedure RadioGroup1Click(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
    procedure RadioGroup2Click(Sender: TObject);
  end;

var
  ErrFuncDlg : TErrFuncDlg;
  ErrModel   : TVarModel;
  VarInY     : Boolean;
  Theta      : PVector;

implementation

{$R *.DFM}

uses
  uWinStr, Help;

procedure TErrFuncDlg.RadioGroup1Click(Sender: TObject);
{ Choix du modle de variance }
begin
  { Initialiser le modle de variance
    et afficher la formule correspondante }
  case RadioGroup1.ItemIndex of
    0 : ErrModel := VAR_CONST;
    1 : ErrModel := VAR_LIN;
    2 : ErrModel := VAR_POL2;
    3 : ErrModel := VAR_POL3;
    4 : ErrModel := VAR_EXPO;
    5 : ErrModel := VAR_POWER;
  end;

  VarInY := (RadioGroup2.ItemIndex = 1);
  { InitModel(RegModel, VarModel, CstPar, VarInY); }
  Label1.Caption := VarFuncName(ErrModel, VarInY);

  { Afficher les options }
  GroupBoxVar.Visible := (ErrModel <> VAR_CONST);
  LabelVar2.Visible := (ErrModel in [VAR_POL2, VAR_POL3]);
  LabelVar3.Visible := (ErrModel = VAR_POL3);
  EditVar2.Visible := LabelVar2.Visible;
  EditVar3.Visible := LabelVar3.Visible;
end;

procedure TErrFuncDlg.RadioGroup2Click(Sender: TObject);
{ Choix de la ponderation en f(X) ou f(Y) }
begin
  VarInY := (RadioGroup2.ItemIndex = 1);
  { InitModel(RegModel, ErrModel, CstPar, VarInY); }
  Label1.Caption := VarFuncName(ErrModel, varInY);
end;

procedure TErrFuncDlg.OKBtnClick(Sender: TObject);
var
  S : string;
  X : Float;
begin
  S := EditVar1.Text;
  if IsNumeric(S, X) then Theta^[1] := X;

  S := EditVar2.Text;
  if IsNumeric(S, X) then Theta^[2] := X;

  S := EditVar3.Text;
  if IsNumeric(S, X) then Theta^[3] := X;
end;

procedure TErrFuncDlg.HelpBtnClick(Sender: TObject);
begin
  HelpDlg.Caption := 'Fonction de variance';
  HelpDlg.Memo1.Lines.Clear;
  HelpDlg.Memo1.Lines.Add('1. Choisissez la fonction permettant de calculer la variance');
  HelpDlg.Memo1.Lines.Add('d''une observation y. La formule correspondante apparat en bleu.');
  HelpDlg.Memo1.Lines.Add('');
  HelpDlg.Memo1.Lines.Add('2. Indiquez si la variance doit tre calcule en fonction de');
  HelpDlg.Memo1.Lines.Add('la variable x ou de la variable y.');
  HelpDlg.Memo1.Lines.Add('');
  HelpDlg.Memo1.Lines.Add('3. Saisissez les paramtres de la fonction de variance.');
  HelpDlg.Memo1.Lines.Add('Seuls les paramtres e1, e2, ... doivent tre spcifis par');
  HelpDlg.Memo1.Lines.Add('l''utilisateur. Le paramtre e0 (variance rsiduelle) est estim');
  HelpDlg.Memo1.Lines.Add('par le programme.');
  HelpDlg.ShowModal;
end;

end.
